package logs

import (
	"context"

	"git.perx.ru/perxis/perxis-go/pkg/options"
)

type Storage interface {
	Init(ctx context.Context) error
	Reset(ctx context.Context) error
	Log(ctx context.Context, entry []*Entry) error
	Find(ctx context.Context, filter *Filter, options *options.FindOptions) ([]*Entry, int, error)
	Delete(ctx context.Context, filter *Filter) error
}
