// Code generated by gowrap. DO NOT EDIT.
// template: ../../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/members/observer -i Observer -t ../../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/collaborators"
	"git.perx.ru/perxis/perxis-go/pkg/members/observer"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements observer.Observer that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   observer.Observer
}

// AccessLoggingMiddleware instruments an implementation of the observer.Observer with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next observer.Observer) observer.Observer {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) OnCollaboratorSet(ctx context.Context, collaborator *collaborators.Collaborator) (delayedTaskID string, err error) {
	begin := time.Now()

	m.logger.Debug("OnCollaboratorSet.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("collaborator", collaborator),
	)

	delayedTaskID, err = m.next.OnCollaboratorSet(ctx, collaborator)

	m.logger.Debug("OnCollaboratorSet.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("delayedTaskID", delayedTaskID),
		zap.Error(err),
	)

	return delayedTaskID, err
}
