//*
//# Расширения (Extensions)
//
//Расширения представляют собой отдельные сервисы предоставляющие дополнительные возможности для пользователей. Сервис
//может предоставлять несколько расширений одновременно.
//
//Для координации взаимодействия используется сервис менеджер расширений (Extension Manager). Для предоставления своих функций в систему сервис должен
//зарегистрироваться на контроллере.
//

// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v4.24.3
// source: extensions/extension_service.proto

package extensions

import (
	context "context"
	common "git.perx.ru/perxis/perxis-go/proto/common"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	ExtensionService_Install_FullMethodName   = "/extensions.ExtensionService/Install"
	ExtensionService_Uninstall_FullMethodName = "/extensions.ExtensionService/Uninstall"
	ExtensionService_Check_FullMethodName     = "/extensions.ExtensionService/Check"
	ExtensionService_Action_FullMethodName    = "/extensions.ExtensionService/Action"
)

// ExtensionServiceClient is the client API for ExtensionService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ExtensionServiceClient interface {
	// Install выполняет установку указанных расширений. Если
	// расширение уже установлены выполняет процесс переустановки. Возвращает longtime операцию
	Install(ctx context.Context, in *InstallRequest, opts ...grpc.CallOption) (*common.Operation, error)
	// Uninstall выполняет удаление указанных расширений.
	Uninstall(ctx context.Context, in *UninstallRequest, opts ...grpc.CallOption) (*common.Operation, error)
	// Check выполняет проверку установки для расширения. При этом расширение проверяет наличие необходимых данных в
	// пространстве или наличие новой версии расширения и сообщает об этом. Никаких действий с данными пространства не
	// производится.
	Check(ctx context.Context, in *CheckRequest, opts ...grpc.CallOption) (*common.Operation, error)
	// Пользовательские Действия (Actions)
	//
	// Пользовательские действия позволяют расширить функционал пользовательского интерфейса путем
	// добавления в интерфейс элементов взаимодействуя с которыми пользователь может вызывать реакцию на
	// сервере или переход в интерфейсе.
	//
	// Пользовательские действия добавляются при установке расширений в системную коллекции `System/Actions`.
	// Коллекция создается автоматически менеджером расширений. При установке так же отображается меню `Действия`
	// доступное для всех пользователей.
	//
	// Примеры пользовательских действий:
	//   - "Собрать сайт" - добавляется Perxis.Web для сборки сайта, доступна пользователю через меню,
	//     параметры space_id, env_id. При вызове выполняется запрос на сервер ProcessAction.
	//   - "Посмотреть задачи" - добавляется Tasks для перехода на коллекцию задач. Отображается в меню,
	//     параметры space_id, env_id.
	//
	// Приложения так же могут использовать действия для вызова обработки в других приложениях при
	// необходимости.
	Action(ctx context.Context, in *ActionRequest, opts ...grpc.CallOption) (*ActionResponse, error)
}

type extensionServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewExtensionServiceClient(cc grpc.ClientConnInterface) ExtensionServiceClient {
	return &extensionServiceClient{cc}
}

func (c *extensionServiceClient) Install(ctx context.Context, in *InstallRequest, opts ...grpc.CallOption) (*common.Operation, error) {
	out := new(common.Operation)
	err := c.cc.Invoke(ctx, ExtensionService_Install_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *extensionServiceClient) Uninstall(ctx context.Context, in *UninstallRequest, opts ...grpc.CallOption) (*common.Operation, error) {
	out := new(common.Operation)
	err := c.cc.Invoke(ctx, ExtensionService_Uninstall_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *extensionServiceClient) Check(ctx context.Context, in *CheckRequest, opts ...grpc.CallOption) (*common.Operation, error) {
	out := new(common.Operation)
	err := c.cc.Invoke(ctx, ExtensionService_Check_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *extensionServiceClient) Action(ctx context.Context, in *ActionRequest, opts ...grpc.CallOption) (*ActionResponse, error) {
	out := new(ActionResponse)
	err := c.cc.Invoke(ctx, ExtensionService_Action_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ExtensionServiceServer is the server API for ExtensionService service.
// All implementations must embed UnimplementedExtensionServiceServer
// for forward compatibility
type ExtensionServiceServer interface {
	// Install выполняет установку указанных расширений. Если
	// расширение уже установлены выполняет процесс переустановки. Возвращает longtime операцию
	Install(context.Context, *InstallRequest) (*common.Operation, error)
	// Uninstall выполняет удаление указанных расширений.
	Uninstall(context.Context, *UninstallRequest) (*common.Operation, error)
	// Check выполняет проверку установки для расширения. При этом расширение проверяет наличие необходимых данных в
	// пространстве или наличие новой версии расширения и сообщает об этом. Никаких действий с данными пространства не
	// производится.
	Check(context.Context, *CheckRequest) (*common.Operation, error)
	// Пользовательские Действия (Actions)
	//
	// Пользовательские действия позволяют расширить функционал пользовательского интерфейса путем
	// добавления в интерфейс элементов взаимодействуя с которыми пользователь может вызывать реакцию на
	// сервере или переход в интерфейсе.
	//
	// Пользовательские действия добавляются при установке расширений в системную коллекции `System/Actions`.
	// Коллекция создается автоматически менеджером расширений. При установке так же отображается меню `Действия`
	// доступное для всех пользователей.
	//
	// Примеры пользовательских действий:
	//   - "Собрать сайт" - добавляется Perxis.Web для сборки сайта, доступна пользователю через меню,
	//     параметры space_id, env_id. При вызове выполняется запрос на сервер ProcessAction.
	//   - "Посмотреть задачи" - добавляется Tasks для перехода на коллекцию задач. Отображается в меню,
	//     параметры space_id, env_id.
	//
	// Приложения так же могут использовать действия для вызова обработки в других приложениях при
	// необходимости.
	Action(context.Context, *ActionRequest) (*ActionResponse, error)
	mustEmbedUnimplementedExtensionServiceServer()
}

// UnimplementedExtensionServiceServer must be embedded to have forward compatible implementations.
type UnimplementedExtensionServiceServer struct {
}

func (UnimplementedExtensionServiceServer) Install(context.Context, *InstallRequest) (*common.Operation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Install not implemented")
}
func (UnimplementedExtensionServiceServer) Uninstall(context.Context, *UninstallRequest) (*common.Operation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Uninstall not implemented")
}
func (UnimplementedExtensionServiceServer) Check(context.Context, *CheckRequest) (*common.Operation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Check not implemented")
}
func (UnimplementedExtensionServiceServer) Action(context.Context, *ActionRequest) (*ActionResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Action not implemented")
}
func (UnimplementedExtensionServiceServer) mustEmbedUnimplementedExtensionServiceServer() {}

// UnsafeExtensionServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ExtensionServiceServer will
// result in compilation errors.
type UnsafeExtensionServiceServer interface {
	mustEmbedUnimplementedExtensionServiceServer()
}

func RegisterExtensionServiceServer(s grpc.ServiceRegistrar, srv ExtensionServiceServer) {
	s.RegisterService(&ExtensionService_ServiceDesc, srv)
}

func _ExtensionService_Install_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(InstallRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ExtensionServiceServer).Install(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ExtensionService_Install_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ExtensionServiceServer).Install(ctx, req.(*InstallRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ExtensionService_Uninstall_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UninstallRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ExtensionServiceServer).Uninstall(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ExtensionService_Uninstall_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ExtensionServiceServer).Uninstall(ctx, req.(*UninstallRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ExtensionService_Check_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CheckRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ExtensionServiceServer).Check(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ExtensionService_Check_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ExtensionServiceServer).Check(ctx, req.(*CheckRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ExtensionService_Action_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ActionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ExtensionServiceServer).Action(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ExtensionService_Action_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ExtensionServiceServer).Action(ctx, req.(*ActionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ExtensionService_ServiceDesc is the grpc.ServiceDesc for ExtensionService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ExtensionService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "extensions.ExtensionService",
	HandlerType: (*ExtensionServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Install",
			Handler:    _ExtensionService_Install_Handler,
		},
		{
			MethodName: "Uninstall",
			Handler:    _ExtensionService_Uninstall_Handler,
		},
		{
			MethodName: "Check",
			Handler:    _ExtensionService_Check_Handler,
		},
		{
			MethodName: "Action",
			Handler:    _ExtensionService_Action_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "extensions/extension_service.proto",
}
